/**
 * Description: CmDeliveryAddress控制器
 * Copyright:   Copyright (c)2015
 * Company:     江苏三六五网络股份有限公司
 * @author:     江苏三六五网络股份有限公司
 * @version:    1.0
 * Create at:   2015-08-10 下午 17:06:12
 *  
 * Modification History:
 * Date         Author      Version     Description
 * ------------------------------------------------------------------
 * 2015-08-10   江苏三六五网络股份有限公司   1.0         Initial
 */
package com.house365.web.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;
import org.springside.modules.web.Servlets;

import com.house365.beans.system.Page;

import com.house365.beans.entity.CmDeliveryAddressEntity;
import com.house365.beans.vo.CmDeliveryAddressVo;

import com.house365.web.system.controller.BaseController;
import com.house365.web.util.StringUtils;
import com.house365.ws.beans.response.CmBrokerLabelResponse;

import com.house365.ws.beans.request.CmDeliveryAddressListRequest;
import com.house365.ws.beans.request.CmDeliveryAddressRequest;
import com.house365.ws.beans.response.CmDeliveryAddressListResponse;
import com.house365.ws.beans.response.CmDeliveryAddressResponse;
import com.house365.ws.interfaces.server.ICmDeliveryAddress;

/**
 * CmDeliveryAddress控制器<br>
 * 
 * @author 江苏三六五网络股份有限公司
 * @version 1.0, 2015-08-10
 * @see
 * @since 1.0
 */
@Controller
@RequestMapping("/cmdeliveryaddress")
public class CmDeliveryAddressController extends BaseController {

	/**
	 * 自动注入CmDeliveryAddressWS实现
	 */
	@Autowired
	private ICmDeliveryAddress cmDeliveryAddress;

	/**
	 * 去新增CmDeliveryAddress
	 * 
	 * @return 结果视图
	 */
	@RequestMapping(value = "", params = "action=create")
	public String createForm(Model model){
		model.addAttribute("action", "create");
		return getAutoUrl("form");
	}

	/**
	 * 新增CmDeliveryAddress
	 * 
	 * @param cmDeliveryAddress CmDeliveryAddress页面表单对象
	 * @param result 表单验证数据
	 * @param page 分页配置
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "", method = { RequestMethod.POST})
	public String createCmDeliveryAddress(@Valid CmDeliveryAddressVo vo, BindingResult result, RedirectAttributes redirectAttributes, Model model){
		CmDeliveryAddressEntity entity = vo.getEntity();
		model.addAttribute("entity", entity);
		// subValidation(result, entity);
		// 表单验证无误,进行提交
		if (result.hasErrors()) {
		    model.addAttribute("action", "create");
            addErrorMessage(model, result.getFieldError().getDefaultMessage());
            return getAutoUrl("form");
		} else {
		    try {
                CmDeliveryAddressRequest request = new CmDeliveryAddressRequest();
                request.setEntity(entity);
                CmDeliveryAddressResponse response = cmDeliveryAddress
                        .addCmDeliveryAddress(request);
                Integer id = response.getEntity().getId();
                return "redirect:/cmdeliveryaddress/" + id;
            } catch (Exception ex) {
                addErrorMessage(model, ex.getMessage());
                model.addAttribute("action", "create");
                return getAutoUrl("form");
            }
		}
	}

	/**
	 * 删除CmDeliveryAddress
	 * 
	 * @param id CmDeliveryAddress页面表单对象唯一标识
	 * @param page 分页配置
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "/{id}", method = { RequestMethod.DELETE })
	@ResponseStatus(HttpStatus.OK)
	public void delete(@PathVariable String id){
	    if(!StringUtils.isEmpty(id))
        {
            if(id.contains(","))
            {
                String[] ids = id.split(",");
                for (int i = 0; i < ids.length; i++) {
                    CmDeliveryAddressResponse response = cmDeliveryAddress.deleteCmDeliveryAddressById(Integer.valueOf(ids[i]));
                }
            }
            else
            {
                CmDeliveryAddressResponse response = cmDeliveryAddress.deleteCmDeliveryAddressById(Integer.valueOf(id));
            }
        }
	}

	/**
	 * 去查看CmDeliveryAddress
	 * 
	 * @param id
	 *            CmDeliveryAddress页面表单对象唯一标识
	 * @param request
	 *            请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "/{id}", method = { RequestMethod.GET })
	public String showForm(@PathVariable(value = "id") Integer id, Model model) {
        CmDeliveryAddressResponse response = cmDeliveryAddress
                .getCmDeliveryAddressById(id);
        model.addAttribute("entity", response.getEntity());
        return getAutoUrl("form");
	}

	/**
	 * 去修改CmDeliveryAddress
	 * 
	 * @param id CmDeliveryAddress页面表单对象唯一标识
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "/{id}", method = { RequestMethod.GET}, params = "action=edit")
	public String updateForm(@PathVariable(value = "id") Integer id, Model model){
        CmDeliveryAddressResponse response = cmDeliveryAddress
                .getCmDeliveryAddressById(id);
        model.addAttribute("entity", response.getEntity());
		model.addAttribute("action", "edit");
		return getAutoUrl("form");
	}

	/**
	 * 修改CmDeliveryAddress
	 * 
	 * @param cmDeliveryAddress CmDeliveryAddress页面表单对象
	 * @param result 表单验证数据
	 * @param page 分页配置
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "/{id}", method = { RequestMethod.POST})
	public String updateCmDeliveryAddress(@Valid CmDeliveryAddressVo vo, BindingResult result, @PathVariable Integer id, RedirectAttributes redirectAttributes, Model model){
		CmDeliveryAddressEntity entity = vo.getEntity();
		model.addAttribute("entity", entity);
		// subValidation(result, entity);
		// 表单验证无误,进行提交
		if (result.hasErrors()) {
		    model.addAttribute("action", "create");
            addErrorMessage(model, result.getFieldError().getDefaultMessage());
            return getAutoUrl("form");
		} else {
            try {
                CmDeliveryAddressRequest request = new CmDeliveryAddressRequest();
                request.setEntity(entity);
                @SuppressWarnings("unused")
                CmDeliveryAddressResponse rersponse = cmDeliveryAddress
                        .updateCmDeliveryAddress(request);
                redirectAttributes.addAttribute("message", "更新成功");
                return "redirect:/cmdeliveryaddress/" + entity.getId();
            } catch (Exception ex) {
                addErrorMessage(model, ex.getMessage());
                model.addAttribute("action", "edit");
                return getAutoUrl("form");
            }
		}
	}

	/**
	 * 查询CmDeliveryAddress
	 * 
	 * @param cmDeliveryAddress CmDeliveryAddress页面表单对象
	 * @param page 分页配置
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "", method = RequestMethod.GET)
	public String list (Integer number, Model model, HttpServletRequest request) {
		// 获取查询条件
		Map<String, Object> searchParams = Servlets.getParametersStartingWith(
				request, "search_");
		Page page = new Page(Page.TWENTY_PAGE_SIZE);
		if (null != number) {
			page.setCurrentPage(number);
		}
		CmDeliveryAddressListRequest listRequest = new CmDeliveryAddressListRequest();
        listRequest.setPaging(page);
        listRequest.setSearchParams(searchParams);
        CmDeliveryAddressListResponse response = cmDeliveryAddress.getCmDeliveryAddressList(listRequest);
        model.addAttribute("page", response.getPaging());
        model.addAttribute("cmDeliveryAddresss", response.getObjectList());
        model.addAttribute("searchParams", Servlets
                .encodeParameterStringWithPrefix(searchParams, "search_"));
		return getAutoUrl();
	}
}
